package edu.mermet.tp8.fenetres;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.text.NumberFormat;
import java.util.Locale;
import java.util.ResourceBundle;

public class FenetreConversionMonnaie extends AbstractFenetreInterne
{
    private JComboBox champMonnaie;
    private JComboBox champMonnaie2;
    private JTextField champMonnaieText;
    private JButton boutonConvertir;
    private Action actionConvertir;
    private JLabel jLabel;
    private ResourceBundle bundle;
    private String[] data = {"France (Euro)", "Anglais (Livre)", "Américain (Dollars)"};

    public FenetreConversionMonnaie(Action action)
    {
        super(action, "Conversion Monnaie");
        this.setSize(new Dimension(100, 50));
        this.setLayout(new GridLayout(3, 2,10,10));



        champMonnaie = new JComboBox(data);
        champMonnaie2 = new JComboBox(data);

        this.add(champMonnaie);
        this.add(champMonnaie2);

        champMonnaieText = new JTextField(15);
        jLabel = new JLabel("= ");

        this.add(champMonnaieText);
        this.add(jLabel);


        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        this.add(boutonConvertir);

        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    private class ActionConvertir extends AbstractAction
    {

        public ActionConvertir()
        {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae)
        {
            String from = getValueOfComboBox(champMonnaie);
            String to = getValueOfComboBox(champMonnaie2);

            double res = 0.0;

            if(from.equals("fr") && to.equals("en"))
                res = euroToLivre();
            if(from.equals("fr") && to.equals("us"))
                res = euroToDollars();

            if(from.equals("en") && to.equals("fr"))
                res = livreToEuro();
            if(from.equals("en") && to.equals("US"))
                res = livreToDollars();

            if(from.equals("us") && to.equals("en"))
                res = dollarsToLivre();
            if(from.equals("us") && to.equals("fr"))
                res = dollarsToEuro();

            NumberFormat nf = NumberFormat.getCurrencyInstance(new Locale(to));
            jLabel.setText("= " + nf.format(res));
        }

        private double dollarsToEuro()
        {
            return Double.parseDouble(champMonnaieText.getText()) * 0.88;
        }

        private double dollarsToLivre()
        {
            return Double.parseDouble(champMonnaieText.getText()) * 0.75;
        }

        private double livreToDollars()
        {
            return Double.parseDouble(champMonnaieText.getText()) * 1.33;
        }

        private double livreToEuro()
        {
            return Double.parseDouble(champMonnaieText.getText()) * 1.17;
        }

        private double euroToDollars()
        {
            return Double.parseDouble(champMonnaieText.getText()) * 1.13;
        }

        private double euroToLivre()
        {
            return Double.parseDouble(champMonnaieText.getText()) * 0.85;
        }
    }

    private String getValueOfComboBox(JComboBox comboBox)
    {
        String sRet = "";
        switch (comboBox.getSelectedIndex())
        {
            case 0:
                sRet = "fr";
                break;
            case 1:
                sRet = "en";
                break;
            case 2:
                sRet = "us";
        }
        return sRet;
    }

    public void propertyChange(PropertyChangeEvent evt)
    {
        bundle = ResourceBundle.getBundle("monnaie", (Locale)evt.getNewValue());
        data[0] = bundle.getString("Euro");
        data[1] = bundle.getString("Livre");
        data[2] = bundle.getString("Dollars");
        champMonnaie.removeAllItems();
        champMonnaie2.removeAllItems();
        for(int i = 0; i < data.length; i++)
        {
            champMonnaie.addItem(data[i]);
            champMonnaie2.addItem(data[i]);
        }

        boutonConvertir.setText(bundle.getString("Convertir"));
    }
}
